window.Gleam.initSearch([{"doc":"gserde","title":"gserde","content":"# gserde\n\n**warning**: alpha package with poor code hygiene, including assert/panic/todo\nstatements. Use understanding that this package is not ready for primetime.\n\n[![Package Version](https://img.shields.io/hexpm/v/gserde)](https://hex.pm/packages/gserde)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/gserde/)\n\n```sh\ngleam add gserde\n```\n\n## usage\n\n1. Create custom type with a singular variant constructor:\n2. Run `gleam run -m gserde`\n3. Observe `src/foo_json.gleam`, which has the goodies you need for json (de)serialization.\n\n```gleam\n// src/foo.gleam\nimport gleam/option.{type Option}\npub type FooJSON {\n  Foo(\n    a_bool: Bool,\n    b_int: Int,\n    c_float: Float,\n    d_two_tuple: #(Int, String),\n    e_option_int: Option(Int),\n    f_string_list: List(String),\n  )\n}\n\n// src/my_module.gleam\nimport foo\nimport foo_json\n\npub fn serialization_identity_test() {\n  let foo_1 = foo.Foo(..)\n\n  let foo_2 = foo_1\n    |&gt; foo_json.to_string // 👀\n    |&gt; foo_json.from_string // 👀\n\n  foo_1 == foo_2\n}\n```\n\n## todo\n\n- [ ] complete all cases\n- [ ] remove all invocations of assert/panic/todo\n- [ ] support non-gleam primitive types\n- [ ] handle all module references properly\n\nFurther documentation can be found at &lt;https://hexdocs.pm/gserde&gt;.\n\n## Development\n\n```sh\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"internal/path","title":"basename","content":"pub fn basename(path: String) -&gt; String\n\nSynonyms:\ninternal/path.basename\ninternal/path basename","url":"internal/path.html#basename"},{"doc":"internal/path","title":"internal/path","content":"","url":"internal/path.html"},{"doc":"internal/foo","title":"FooJSON","content":"pub type FooJSON {\n  Foo(\n    a_bool: Bool,\n    b_int: Int,\n    c_float: Float,\n    d_two_tuple: #(Int, String),\n    e_option_int: Option(Int),\n    f_string_list: List(String),\n  )\n}\n\nFoo(\n  a_bool: Bool,\n  b_int: Int,\n  c_float: Float,\n  d_two_tuple: #(Int, String),\n  e_option_int: Option(Int),\n  f_string_list: List(String),\n)\n\n\nSynonyms:\ninternal/foo.FooJSON\ninternal/foo FooJSON","url":"internal/foo.html#FooJSON"},{"doc":"internal/foo","title":"internal/foo","content":"","url":"internal/foo.html"},{"doc":"internal/foo_json","title":"from_json","content":"pub fn from_json(\n  json_str: String,\n) -&gt; Result(FooJSON, DecodeError)\n\nSynonyms:\ninternal/foo_json.from_json\ninternal/foo_json from_json","url":"internal/foo_json.html#from_json"},{"doc":"internal/foo_json","title":"to_json","content":"pub fn to_json(t: FooJSON) -&gt; Json\n\nSynonyms:\ninternal/foo_json.to_json\ninternal/foo_json to_json","url":"internal/foo_json.html#to_json"},{"doc":"internal/foo_json","title":"to_string","content":"pub fn to_string(t: FooJSON) -&gt; String\n\nSynonyms:\ninternal/foo_json.to_string\ninternal/foo_json to_string","url":"internal/foo_json.html#to_string"},{"doc":"internal/foo_json","title":"internal/foo_json","content":"","url":"internal/foo_json.html"},{"doc":"internal/foo_json_test","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\ninternal/foo_json_test.main\ninternal/foo_json_test main","url":"internal/foo_json_test.html#main"},{"doc":"internal/foo_json_test","title":"internal/foo_json_test","content":"","url":"internal/foo_json_test.html"},{"doc":"internal/codegen/types","title":"Field","content":"pub type Field {\n  Field(name: String, field_type: GleamType)\n}\n\nField(name: String, field_type: GleamType)\n\n\nSynonyms:\ninternal/codegen/types.Field\ninternal/codegen/types Field","url":"internal/codegen/types.html#Field"},{"doc":"internal/codegen/types","title":"GleamType","content":"pub type GleamType {\n  AnonymousType(String)\n  NilType\n  IntType\n  TupleType(elements: List(GleamType))\n  ListType(list_type: GleamType)\n  VariantType(name: String, variants: List(Variant))\n  VariantDepType(\n    name: String,\n    dep_types: List(GleamType),\n    variants: List(Variant),\n  )\n  FunctionType(\n    argument_types: List(GleamType),\n    result_type: GleamType,\n  )\n}\n\nAnonymousType(String)\n\n\nNilType\n\n\nIntType\n\n\nTupleType(elements: List(GleamType))\n\n\nListType(list_type: GleamType)\n\n\nVariantType(name: String, variants: List(Variant))\n\n\nVariantDepType(\n  name: String,\n  dep_types: List(GleamType),\n  variants: List(Variant),\n)\n\n\nFunctionType(\n  argument_types: List(GleamType),\n  result_type: GleamType,\n)\n\n\nSynonyms:\ninternal/codegen/types.GleamType\ninternal/codegen/types GleamType","url":"internal/codegen/types.html#GleamType"},{"doc":"internal/codegen/types","title":"Variant","content":"pub type Variant {\n  Variant(name: String, fields: List(Field))\n}\n\nVariant(name: String, fields: List(Field))\n\n\nSynonyms:\ninternal/codegen/types.Variant\ninternal/codegen/types Variant","url":"internal/codegen/types.html#Variant"},{"doc":"internal/codegen/types","title":"field","content":"pub fn field(name: String, field_type: GleamType) -&gt; Field\n\nSynonyms:\ninternal/codegen/types.field\ninternal/codegen/types field","url":"internal/codegen/types.html#field"},{"doc":"internal/codegen/types","title":"function","content":"pub fn function(\n  argument_types: List(GleamType),\n  result_type: GleamType,\n) -&gt; GleamType\n\nSynonyms:\ninternal/codegen/types.function\ninternal/codegen/types function","url":"internal/codegen/types.html#function"},{"doc":"internal/codegen/types","title":"generate_type","content":"pub fn generate_type(arg_type: GleamType) -&gt; String\n\nSynonyms:\ninternal/codegen/types.generate_type\ninternal/codegen/types generate_type","url":"internal/codegen/types.html#generate_type"},{"doc":"internal/codegen/types","title":"generate_type_def","content":"pub fn generate_type_def(gleam_type: GleamType) -&gt; String\n\nSynonyms:\ninternal/codegen/types.generate_type_def\ninternal/codegen/types generate_type_def","url":"internal/codegen/types.html#generate_type_def"},{"doc":"internal/codegen/types","title":"int","content":"pub fn int() -&gt; GleamType\n\nSynonyms:\ninternal/codegen/types.int\ninternal/codegen/types int","url":"internal/codegen/types.html#int"},{"doc":"internal/codegen/types","title":"nil","content":"pub fn nil() -&gt; GleamType\n\nSynonyms:\ninternal/codegen/types.nil\ninternal/codegen/types nil","url":"internal/codegen/types.html#nil"},{"doc":"internal/codegen/types","title":"option","content":"pub fn option(some_type: GleamType) -&gt; GleamType\n\nSynonyms:\ninternal/codegen/types.option\ninternal/codegen/types option","url":"internal/codegen/types.html#option"},{"doc":"internal/codegen/types","title":"result","content":"pub fn result(\n  ok_type: GleamType,\n  error_type: GleamType,\n) -&gt; GleamType\n\nSynonyms:\ninternal/codegen/types.result\ninternal/codegen/types result","url":"internal/codegen/types.html#result"},{"doc":"internal/codegen/types","title":"variant","content":"pub fn variant(name: String, fields: List(Field)) -&gt; Variant\n\nSynonyms:\ninternal/codegen/types.variant\ninternal/codegen/types variant","url":"internal/codegen/types.html#variant"},{"doc":"internal/codegen/types","title":"variant_type","content":"pub fn variant_type(\n  name: String,\n  variants: List(Variant),\n) -&gt; GleamType\n\nSynonyms:\ninternal/codegen/types.variant_type\ninternal/codegen/types variant_type","url":"internal/codegen/types.html#variant_type"},{"doc":"internal/codegen/types","title":"internal/codegen/types","content":"","url":"internal/codegen/types.html"},{"doc":"internal/codegen/statements","title":"Argument","content":"pub opaque type Argument\n\n\nSynonyms:\ninternal/codegen/statements.Argument\ninternal/codegen/statements Argument","url":"internal/codegen/statements.html#Argument"},{"doc":"internal/codegen/statements","title":"Clause","content":"pub opaque type Clause\n\n\nSynonyms:\ninternal/codegen/statements.Clause\ninternal/codegen/statements Clause","url":"internal/codegen/statements.html#Clause"},{"doc":"internal/codegen/statements","title":"ComparisonOperator","content":"pub type ComparisonOperator {\n  Lt\n  Lte\n  Eq\n  Neq\n  Gt\n  Gte\n}\n\nLt\n\n\nLte\n\n\nEq\n\n\nNeq\n\n\nGt\n\n\nGte\n\n\nSynonyms:\ninternal/codegen/statements.ComparisonOperator\ninternal/codegen/statements ComparisonOperator","url":"internal/codegen/statements.html#ComparisonOperator"},{"doc":"internal/codegen/statements","title":"GleamStatement","content":"pub type GleamStatement {\n  NilVal\n  IntVal(value: Int)\n  ListVal(items: List(GleamStatement))\n  StringVal(string: String)\n  TupleVal(items: List(GleamStatement))\n  VariantVal(name: String, fields: List(GleamStatement))\n  VarPrimitive(name: String)\n  Comparison(GleamStatement, ComparisonOperator, GleamStatement)\n  CaseStatement(\n    guards: List(GleamStatement),\n    clauses: List(Clause),\n  )\n  Function(\n    name: String,\n    arguments: List(Argument),\n    statements: List(GleamStatement),\n  )\n  FunctionCall(name: String, arguments: List(GleamStatement))\n  UseArg(arg: GleamStatement)\n  LetVar(pattern: Pattern, statement: GleamStatement)\n  LetArray(patterns: List(Pattern), array: GleamStatement)\n  LetTuple(patterns: List(Pattern), tuple: GleamStatement)\n  Multiply(terms: List(GleamStatement))\n  Direct(string: String)\n}\n Direct is a string that will be in the generated code, verbatim.\nNilVal\n\n\nIntVal(value: Int)\n\n\nListVal(items: List(GleamStatement))\n\n\nStringVal(string: String)\n\n\nTupleVal(items: List(GleamStatement))\n\n\nVariantVal(name: String, fields: List(GleamStatement))\n\n\nVarPrimitive(name: String)\n\n\nComparison(GleamStatement, ComparisonOperator, GleamStatement)\n\n\nCaseStatement(\n  guards: List(GleamStatement),\n  clauses: List(Clause),\n)\n\n\nFunction(\n  name: String,\n  arguments: List(Argument),\n  statements: List(GleamStatement),\n)\n\n\nFunctionCall(name: String, arguments: List(GleamStatement))\n\n\nUseArg(arg: GleamStatement)\n\n\nLetVar(pattern: Pattern, statement: GleamStatement)\n\n\nLetArray(patterns: List(Pattern), array: GleamStatement)\n\n\nLetTuple(patterns: List(Pattern), tuple: GleamStatement)\n\n\nMultiply(terms: List(GleamStatement))\n\n\nDirect(string: String)\n\n\nSynonyms:\ninternal/codegen/statements.GleamStatement\ninternal/codegen/statements GleamStatement","url":"internal/codegen/statements.html#GleamStatement"},{"doc":"internal/codegen/statements","title":"Pattern","content":"pub opaque type Pattern\n\n\nSynonyms:\ninternal/codegen/statements.Pattern\ninternal/codegen/statements Pattern","url":"internal/codegen/statements.html#Pattern"},{"doc":"internal/codegen/statements","title":"arg_typed","content":"pub fn arg_typed(name: String, arg_type: GleamType) -&gt; Argument\n\nSynonyms:\ninternal/codegen/statements.arg_typed\ninternal/codegen/statements arg_typed","url":"internal/codegen/statements.html#arg_typed"},{"doc":"internal/codegen/statements","title":"arg_untyped","content":"pub fn arg_untyped(name: String) -&gt; Argument\n\nSynonyms:\ninternal/codegen/statements.arg_untyped\ninternal/codegen/statements arg_untyped","url":"internal/codegen/statements.html#arg_untyped"},{"doc":"internal/codegen/statements","title":"call","content":"pub fn call(\n  name: String,\n  arguments: List(GleamStatement),\n) -&gt; GleamStatement\n\nSynonyms:\ninternal/codegen/statements.call\ninternal/codegen/statements call","url":"internal/codegen/statements.html#call"},{"doc":"internal/codegen/statements","title":"case_stmt","content":"pub fn case_stmt(\n  guards: List(GleamStatement),\n  clauses: List(Clause),\n) -&gt; GleamStatement\n\nSynonyms:\ninternal/codegen/statements.case_stmt\ninternal/codegen/statements case_stmt","url":"internal/codegen/statements.html#case_stmt"},{"doc":"internal/codegen/statements","title":"clause","content":"pub fn clause(\n  patterns: List(Pattern),\n  stmt: GleamStatement,\n) -&gt; Clause\n\nSynonyms:\ninternal/codegen/statements.clause\ninternal/codegen/statements clause","url":"internal/codegen/statements.html#clause"},{"doc":"internal/codegen/statements","title":"compare","content":"pub fn compare(\n  stmt1: GleamStatement,\n  comp_op: ComparisonOperator,\n  stmt2: GleamStatement,\n) -&gt; GleamStatement\n\nSynonyms:\ninternal/codegen/statements.compare\ninternal/codegen/statements compare","url":"internal/codegen/statements.html#compare"},{"doc":"internal/codegen/statements","title":"direct","content":"pub fn direct(string: String) -&gt; GleamStatement\n @deprecated\nSynonyms:\ninternal/codegen/statements.direct\ninternal/codegen/statements direct","url":"internal/codegen/statements.html#direct"},{"doc":"internal/codegen/statements","title":"error","content":"pub fn error(error: GleamStatement) -&gt; GleamStatement\n\nSynonyms:\ninternal/codegen/statements.error\ninternal/codegen/statements error","url":"internal/codegen/statements.html#error"},{"doc":"internal/codegen/statements","title":"function","content":"pub fn function(\n  name: String,\n  arguments: List(Argument),\n  statements: List(GleamStatement),\n) -&gt; GleamStatement\n\nSynonyms:\ninternal/codegen/statements.function\ninternal/codegen/statements function","url":"internal/codegen/statements.html#function"},{"doc":"internal/codegen/statements","title":"generate","content":"pub fn generate(stmt: GleamStatement) -&gt; String\n\nSynonyms:\ninternal/codegen/statements.generate\ninternal/codegen/statements generate","url":"internal/codegen/statements.html#generate"},{"doc":"internal/codegen/statements","title":"int","content":"pub fn int(value: Int) -&gt; GleamStatement\n\nSynonyms:\ninternal/codegen/statements.int\ninternal/codegen/statements int","url":"internal/codegen/statements.html#int"},{"doc":"internal/codegen/statements","title":"let_array","content":"pub fn let_array(\n  patterns: List(Pattern),\n  array: GleamStatement,\n) -&gt; GleamStatement\n TODO: Needs middle argument `Option(Pattern)` for `..tail`\nSynonyms:\ninternal/codegen/statements.let_array\ninternal/codegen/statements let_array","url":"internal/codegen/statements.html#let_array"},{"doc":"internal/codegen/statements","title":"let_tuple","content":"pub fn let_tuple(\n  patterns: List(Pattern),\n  tuple: GleamStatement,\n) -&gt; GleamStatement\n\nSynonyms:\ninternal/codegen/statements.let_tuple\ninternal/codegen/statements let_tuple","url":"internal/codegen/statements.html#let_tuple"},{"doc":"internal/codegen/statements","title":"let_var","content":"pub fn let_var(\n  pattern: Pattern,\n  statement: GleamStatement,\n) -&gt; GleamStatement\n\nSynonyms:\ninternal/codegen/statements.let_var\ninternal/codegen/statements let_var","url":"internal/codegen/statements.html#let_var"},{"doc":"internal/codegen/statements","title":"list","content":"pub fn list(values: List(GleamStatement)) -&gt; GleamStatement\n\nSynonyms:\ninternal/codegen/statements.list\ninternal/codegen/statements list","url":"internal/codegen/statements.html#list"},{"doc":"internal/codegen/statements","title":"literal","content":"pub fn literal(lit: String) -&gt; Pattern\n a constant patter, such as `True` or `42` (represented as a string, for now)\nSynonyms:\ninternal/codegen/statements.literal\ninternal/codegen/statements literal","url":"internal/codegen/statements.html#literal"},{"doc":"internal/codegen/statements","title":"multiply","content":"pub fn multiply(terms: List(GleamStatement)) -&gt; GleamStatement\n\nSynonyms:\ninternal/codegen/statements.multiply\ninternal/codegen/statements multiply","url":"internal/codegen/statements.html#multiply"},{"doc":"internal/codegen/statements","title":"name_of_var","content":"pub fn name_of_var(var: GleamStatement) -&gt; String\n\nSynonyms:\ninternal/codegen/statements.name_of_var\ninternal/codegen/statements name_of_var","url":"internal/codegen/statements.html#name_of_var"},{"doc":"internal/codegen/statements","title":"nil","content":"pub fn nil() -&gt; GleamStatement\n\nSynonyms:\ninternal/codegen/statements.nil\ninternal/codegen/statements nil","url":"internal/codegen/statements.html#nil"},{"doc":"internal/codegen/statements","title":"ok","content":"pub fn ok(value: GleamStatement) -&gt; GleamStatement\n\nSynonyms:\ninternal/codegen/statements.ok\ninternal/codegen/statements ok","url":"internal/codegen/statements.html#ok"},{"doc":"internal/codegen/statements","title":"underscore","content":"pub fn underscore() -&gt; Pattern\n\nSynonyms:\ninternal/codegen/statements.underscore\ninternal/codegen/statements underscore","url":"internal/codegen/statements.html#underscore"},{"doc":"internal/codegen/statements","title":"unused_var","content":"pub fn unused_var(name: String) -&gt; Pattern\n name: variable name without the underscore, it will be prepended when generating code\nSynonyms:\ninternal/codegen/statements.unused_var\ninternal/codegen/statements unused_var","url":"internal/codegen/statements.html#unused_var"},{"doc":"internal/codegen/statements","title":"use_arg","content":"pub fn use_arg(arg: Argument) -&gt; GleamStatement\n\nSynonyms:\ninternal/codegen/statements.use_arg\ninternal/codegen/statements use_arg","url":"internal/codegen/statements.html#use_arg"},{"doc":"internal/codegen/statements","title":"var_pattern","content":"pub fn var_pattern(var: String) -&gt; Pattern\n\nSynonyms:\ninternal/codegen/statements.var_pattern\ninternal/codegen/statements var_pattern","url":"internal/codegen/statements.html#var_pattern"},{"doc":"internal/codegen/statements","title":"variable","content":"pub fn variable(name: String) -&gt; GleamStatement\n\nSynonyms:\ninternal/codegen/statements.variable\ninternal/codegen/statements variable","url":"internal/codegen/statements.html#variable"},{"doc":"internal/codegen/statements","title":"variant","content":"pub fn variant(\n  name: String,\n  field_values: List(GleamStatement),\n) -&gt; GleamStatement\n\nSynonyms:\ninternal/codegen/statements.variant\ninternal/codegen/statements variant","url":"internal/codegen/statements.html#variant"},{"doc":"internal/codegen/statements","title":"internal/codegen/statements","content":"","url":"internal/codegen/statements.html"},{"doc":"request","title":"Request","content":"pub type Request {\n  Request(\n    src_module_name: String,\n    type_name: String,\n    variant: glance.Variant,\n    ser: Bool,\n    de: Bool,\n  )\n}\n\nRequest(\n  src_module_name: String,\n  type_name: String,\n  variant: glance.Variant,\n  ser: Bool,\n  de: Bool,\n)\n\n\nSynonyms:\nrequest.Request\nrequest Request","url":"request.html#Request"},{"doc":"request","title":"request","content":"","url":"request.html"},{"doc":"internal/serializer","title":"from","content":"pub fn from(req: Request) -&gt; String\n\nSynonyms:\ninternal/serializer.from\ninternal/serializer from","url":"internal/serializer.html#from"},{"doc":"internal/serializer","title":"get_json_serializer_str","content":"pub fn get_json_serializer_str(ct: GleamType) -&gt; String\n\nSynonyms:\ninternal/serializer.get_json_serializer_str\ninternal/serializer get_json_serializer_str","url":"internal/serializer.html#get_json_serializer_str"},{"doc":"internal/serializer","title":"internal/serializer","content":"","url":"internal/serializer.html"},{"doc":"internal/deserializer","title":"to","content":"pub fn to(req: Request) -&gt; String\n\nSynonyms:\ninternal/deserializer.to\ninternal/deserializer to","url":"internal/deserializer.html#to"},{"doc":"internal/deserializer","title":"internal/deserializer","content":"","url":"internal/deserializer.html"},{"doc":"gserde","title":"gen","content":"pub fn gen(req: Request) -&gt; #(Request, String)\n\nSynonyms:\ngserde.gen\ngserde gen","url":"gserde.html#gen"},{"doc":"gserde","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\ngserde.main\ngserde main","url":"gserde.html#main"},{"doc":"gserde","title":"process_single","content":"pub fn process_single(src_filename: String) -&gt; Nil\n\nSynonyms:\ngserde.process_single\ngserde process_single","url":"gserde.html#process_single"},{"doc":"gserde","title":"gserde","content":"","url":"gserde.html"}]);